<template>
    <div class="my-6">
        <div class="d-flex  my-6">
            <v-btn color="primary" @click="openTagDialog">
                <v-icon left>mdi-plus</v-icon>
                <span>{{ $t('add_tag') }}</span>
            </v-btn>
        </div>

        <v-simple-table class="transparent my-3">
            <template v-slot:default>
                <thead>
                <tr>
                    <th class="text-left">{{ $t('tag') }}</th>
                    <th class="text-left">{{ $t('warehouse') }}</th>
                    <th class="text-left">{{ $t('shipped_to') }}</th>
                    <th class="text-left">{{ $t('status') }}</th>
                    <th class="text-left">{{ $t('action') }}</th>
                </tr>
                <tr v-if="loading" class="v-data-table__progress">
                    <th colspan="4">
                        <v-progress-linear color="primary" indeterminate></v-progress-linear>
                    </th>
                </tr>
                </thead>
                <tbody>
                    <tr v-if="items.length === 0">
                        <td colspan="4" class="text-center">{{ $t('no_data') }}</td>
                    </tr>
                    <tr
                        v-else
                        v-for="item in items"
                        :key="item.id"
                    >
                        <td>{{ item.tag }}</td>
                        <td>{{ item.warehouse.name }}</td>
                        <td>{{ item.shipped_out_tracks.length > 0 ? item.shipped_out_tracks[0].user.email : $t('-') }}</td>
                        <td>{{ $t(item.status.name) }}</td>
                        <td>
                            <v-menu
                                :close-on-content-click="false"
                                offset-y
                                bottom
                            >
                                <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        color="primary"
                                        dark
                                        icon
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                        <v-icon>mdi-dots-horizontal</v-icon>
                                    </v-btn>
                                </template>

                                <v-list dense>
                                    <v-list-item>
                                        <v-btn
                                            @click="openEditTagDialog(item)"
                                            class="text-capitalize"
                                            color="primary"
                                            text
                                            block
                                        >
                                            <v-icon left>mdi-pencil</v-icon>
                                            {{ $t('edit') }}
                                        </v-btn>
                                    </v-list-item>
                                    <v-divider class="my-2"></v-divider>
                                    <v-list-item>
                                        <v-btn
                                            @click="openDeleteDialog(item)"
                                            class="text-capitalize"
                                            color="error"
                                            text
                                            block
                                        >
                                            <v-icon left>mdi-delete</v-icon>
                                            {{ $t('delete') }}
                                        </v-btn>
                                    </v-list-item>
                                </v-list>
                            </v-menu>
                        </td>
                    </tr>
                </tbody>

                <!-- Delete Tag -->
                <v-dialog
                    v-model="deleteDialog"
                    persistent
                    max-width="300"
                >
                    <v-card>
                        <v-card-title class="headline primary white--text">
                            {{ $t('delete_', [$t('product')]) }}
                        </v-card-title>

                        <v-card-text class="pt-2">
                            <p class="pt-2 mb-2">{{ $t('del_desc_1') }}</p>
                            <p>{{ $t('del_desc_2') }}</p>
                        </v-card-text>

                        <v-card-actions class="justify-center">
                            <v-btn
                                color="primary"
                                :loading="loading"
                                @click="closeDeleteDialog"
                                text
                            >
                                {{ $t('no') }}
                            </v-btn>

                            <v-btn
                                color="primary"
                                :loading="loading"
                                @click="deleteTag"
                                text
                            >
                                {{ $t('yes') }}
                            </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>

                <v-dialog
                    v-model="tagDialog"
                    persistent
                    max-width="600px"
                >
                    <v-card>
                        <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                            <v-card-title>
                                <span class="headline">{{ $t('product_', [$t('tag')]) }}</span>
                                <v-spacer></v-spacer>
                            </v-card-title>
                            <v-card-text>
                                <v-container>
                                    <v-row>
                                        <v-col>
                                            <div class="field-label">{{ $t('warehouse') }}</div>
                                                <ValidationProvider v-slot="{ errors }" name="warehouse" rules="required">
                                                    <v-warehouse-select
                                                        v-if="updating"
                                                        v-model= "updating.warehouse_id"
                                                        :errors="errors"
                                                        :placeholder="$t('product_', [$t('warehouse')])"
                                                        outlined
                                                    >
                                                    </v-warehouse-select>
                                                    <v-warehouse-select
                                                        v-else
                                                        v-model="addTags.warehouse_id"
                                                        :errors="errors"
                                                        :placeholder="$t('product_', [$t('warehouse')])"
                                                        outlined
                                                    >
                                                    </v-warehouse-select>
                                                </ValidationProvider>
                                        </v-col>

                                        <v-col cols="12">
                                            <div class="field-label">{{ $t('status') }}</div>
                                            <ValidationProvider v-slot="{ errors }" name="status" rules="required">
                                                <v-stock-status-select
                                                    v-if="updating"
                                                    v-model="updating.stock_status_id"
                                                    :errors="errors"
                                                    :placeholder="$t('product_', [$t('status')])"
                                                >
                                                </v-stock-status-select>
                                                <v-stock-status-select
                                                    v-else
                                                    v-model="addTags.stock_status_id"
                                                    :errors="errors"
                                                    :placeholder="$t('product_', [$t('status')])"
                                                >
                                                </v-stock-status-select>
                                            </ValidationProvider>
                                        </v-col>

                                        <v-col cols="12" v-if="updating">
                                            <div class="field-label">{{ $t('tag') }}</div>
                                            <ValidationProvider v-slot="{ errors }" name="tag id" rules="required">
                                                <v-text-field
                                                    v-model="updating.tag"
                                                    :error-messages="errors"
                                                    @keydown.space.prevent
                                                    outlined
                                                ></v-text-field>
                                            </ValidationProvider>
                                        </v-col>


                                        <v-col cols="12" v-if="!updating">
                                            <div class="field-label">{{ $t('tag') }}</div>
                                            <div class="py-3">
                                                <v-alert
                                                    text
                                                    outlined
                                                    color="info"
                                                    icon="mdi-alert"
                                                >
                                                    {{$t('tag_hint')}}
                                                </v-alert>
                                            </div>
                                            <v-text-field
                                                v-model="addTags.tags"
                                                autofocus
                                                outlined
                                                @keydown.enter="scannedTag"
                                                :hint="$t('tag_hint')"
                                            ></v-text-field>
                                        </v-col>

                                        <v-col cols="12" v-if="!updating">
                                            <div class="field-label">{{ $t('scanned') }}</div>
                                            <v-list outlined rounded min-height="60">
                                                <v-list-item
                                                    v-for="(item, index) in addTags.scanned"
                                                    :key="index"
                                                >
                                                    <template>
                                                        <v-chip
                                                            class="chip-block d-flex flex-grow-1"
                                                            tag="div"
                                                            color="primary"
                                                            label
                                                            close
                                                            :disabled="loading"
                                                            @click:close="removeScanned(item)"
                                                        >
                                                            <v-icon>mdi-tag</v-icon>
                                                            <span class="px-2">{{ item }}</span>
                                                            <v-spacer></v-spacer>
                                                            <v-icon small>mdi-circle-close</v-icon>
                                                        </v-chip>
                                                    </template>
                                                </v-list-item>
                                            </v-list>
                                            <div
                                                v-if="addTags.error"
                                                class="pa-2 v-messages error--text"
                                            >
                                                {{ addTags.error }}
                                            </div>
                                        </v-col>
                                    </v-row>
                                </v-container>
                            </v-card-text>
                            <v-card-actions class="py-5 justify-center">
                                <v-btn
                                    color="primary"
                                    :loading="loading"
                                    @click="closeTagDialog"
                                >
                                    <v-icon left>mdi-close</v-icon>
                                    {{ $t('close') }}
                                </v-btn>
                                <v-btn
                                    color="primary"
                                    :loading="loading"
                                    @click="updating ? updateTag() : addProductTag()"
                                >
                                    <v-icon left>mdi-content-save</v-icon>
                                    {{ $t('save') }}
                                </v-btn>
                            </v-card-actions>
                        </ValidationObserver>
                    </v-card>

                </v-dialog>
            </template>
        </v-simple-table>
    </div>
</template>

<script>
    import VWarehouseSelect from "./VWarehouseSelect";
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import { mapMutations } from "vuex";
    import VStockStatusSelect from "./VStockStatusSelect";


    export default {
        name: "VProductTagTable",
        props: {
            stock_id: Number
        },
        components: {
            ValidationObserver,
            ValidationProvider,
            VWarehouseSelect,
            VStockStatusSelect,
        },
        data: () => ({
            loading: true,
            deleteDialog: false,
            editDialog: false,
            warehouse: '',
            items: [],
            tag_id: [],
            productTagId: '',
            stock_status_id: '',
            deleting: null,
            tagDialog: false,
            updating: null,
            addTags: {
                warehouse_id: '',
                tags: '',
                stock_status_id: '',
                scanned: [],
                error: ''
            }
        }),

        mounted() {
            this.fetchTags()
                .then(data => {
                    this.items = data;
                    this.loading = false;
                });
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchTags() {
                this.loading = true;

                return new Promise((resolve, reject) => {
                    axios.get(`api/products/tags/${this.stock_id}`)
                        .then(({data}) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            async updateTag() {
                this.loading = true;

                const isValid = await this.$refs.observer.validate();

                if (!isValid) {
                    this.loading = false;
                    return;
                }

                axios.put(`api/products/tags/${this.updating.id}`, this.updating)
                    .then(({ data }) => {
                        const index = this.items.findIndex(t => t.id === this.updating.id);
                        this.$set(this.items, index, data);
                        this.success(this.$t('product_action.tag.updated'));
                        this.closeTagDialog();
                    })
                    .catch(({ response }) => {
                        let fields = [ 'warehouse_id', 'tags' , 'stock_status_id']
                        let message = response.data.message
                        for(let i=0; i < fields.length; i++){
                            if(fields[i] in response.data.errors){
                                let field = fields[i];
                                message = response.data.errors[field][0]
                                break;
                            }
                        }

                        this.error(message)
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            onChange(val) {
                this.$emit('input', val);
            },

            openDeleteDialog(item) {
                this.deleting = item;
                this.deleteDialog = true;
            },

            closeDeleteDialog() {
                this.deleting = null;
                this.deleteDialog = false;
            },

            deleteTag() {
                this.loading = true;

                const payload = {
                    data: {
                        ids: this.deleting.id
                    }
                };

                axios.delete(`api/products/tags/${this.stock_id}`, payload)
                    .then(() => {
                        const index = this.items.findIndex(tag => tag.id === this.deleting.id);
                        this.items.splice(index, 1);
                        this.success(this.$t('product_action.tag.deleted'));
                        this.closeDeleteDialog();
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            openEditTagDialog(item){
                this.updating = {
                    id: item.id,
                    tag: item.tag,
                    warehouse_id: item.warehouse.id,
                    stock_status_id: item.status.id,
                };
                this.tagDialog = true;
            },

            openTagDialog() {
                this.updating = null;
                this.addTags = {
                    warehouse_id: '',
                    tags: '',
                    scanned:[],
                    stock_status_id: '',
                    error: ''
                }

                this.tagDialog = true;
            },

            closeTagDialog() {
                this.$refs.observer.reset();
                this.updating = null;
                this.tagDialog = false;
            },

            async addProductTag() {
                this.loading = true;

                const isValid = await this.$refs.observer.validate();

                if (!isValid) {
                    this.loading = false;
                    return;
                }

                if(!!this.addTags.scanned.length) {
                    this.addTags.error = ''
                }
                else {
                    this.loading = false;
                    this.addTags.error = this.$t('validation.required', { _field_: this.$t('tag') })
                    return;
                }

                axios.post(`api/products/tags/${this.stock_id}`, {
                    tags: this.addTags.scanned,
                    warehouse_id: this.addTags.warehouse_id,
                    stock_status_id: this.addTags.stock_status_id
                })
                    .then(({ data }) => {
                        data.forEach(element => {
                            this.items.push(element);
                        });

                        this.success(this.$t('product_action.tag.created'));
                        this.closeTagDialog();
                        this.$refs.observer.reset();
                    })
                    .catch(({ response }) => {
                        let fields = [ 'warehouse_id', 'tags' , 'stock_status_id']
                        let message = response.data.message
                        for(let i=0; i < fields.length; i++){
                            if(fields[i] in response.data.errors){
                                let field = fields[i];
                                message = response.data.errors[field][0]
                                break;
                            }
                        }

                        this.error(message)
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            scannedTag(){
                this.addTags.scanned.push(this.addTags.tags)
                this.addTags.tags = ''
            },

            removeScanned(item) {
                let key = item instanceof Object ? item.tags : item

                const index = this.addTags.scanned.findIndex(s => s === key)
                this.addTags.scanned.splice(index, 1)
            },

        }
    }
</script>

<style scoped>
    .chip-block >>> .v-chip__content {
        display: flex;
        width: 100%;
    }
</style>
